import{s as De,f as je,n as Ee,o as Fe}from"../chunks/scheduler.63274e7e.js";import{S as Ye,i as qe,g as s,s as i,r as k,A as ze,h as o,f as l,c as a,j as Se,u as j,x as r,k as q,y as Be,a as n,v as S,d as D,t as E,w as F}from"../chunks/index.bf3f3f8e.js";import{H as Y}from"../chunks/Heading.500d2301.js";function Ge(ve){let m,G,z,V,u,N,g,ye='In this game, we want to run a sentence similarity model, I’m going to use <a href="https://huggingface.co/sentence-transformers/all-MiniLM-L6-v2" rel="nofollow">all-MiniLM-L6-v2</a>.',O,p,$e="It’s a BERT Transformer model. It’s <strong>already trained so we can use it directly.</strong>",J,f,we="But here, I have two solutions to run it, I can:",K,d,Te="<li><em>Run this AI model remotely</em>: <strong>on a server</strong>. I send API calls and get responses from the server. That requires an internet connection.</li> <li><em>Run this AI model locally</em>: <strong>on the player’s machine.</strong></li>",Q,h,_e="Both are valid solutions, <strong>but they have advantages and disadvantages</strong>.",W,c,X,v,Le="I run the model <strong>on a remote server</strong>, and send API calls from the game. I can use an API service to help deploy the model.",Z,y,Me,ee,$,Ie='For instance, Hugging Face provides an API service called <a href="https://huggingface.co/inference-api" rel="nofollow">Inference API</a> (free for prototyping and experimentation) that allows you to use AI models via simple API calls. And we have a <a href="https://huggingface.co/blog/unity-api" rel="nofollow">Unity plugin</a> to access and use Hugging Face AI models from within Unity projects.',te,w,le,T,He="<li>You’re not using the RAM/VRAM of your player to run the model.</li> <li>Your server can log the data, so you can understand what actions players usually type and thus you can improve your NPC.</li>",ne,_,ie,L,Ae="<li><strong>Dependence on an internet connection</strong>, risking immersion disruption due to potential API lag.</li> <li><strong>Potential high cost associated with API usage</strong>, especially with many players.</li>",ae,M,xe="Usually, you use an API if you use a very big model that couldn’t run on a player machine. For instance if you use big models like Llama 2.",se,I,oe,H,Pe="I run the model locally: on the player machine. To be able to do that I use two libraries.",re,A,Ce='<li><p><a href="https://docs.unity3d.com/Packages/com.unity.sentis@latest" rel="nofollow">Unity Sentis</a>: the neural network inference library that allow us to run our AI model directly inside our game.</p></li> <li><p><a href="https://github.com/huggingface/sharp-transformers" rel="nofollow">The Hugging Face Sharp Transformers library</a>: a Unity plugin of utilities to run Transformer 🤗 models in Unity games.</p></li>',me,x,be,ue,P,ge,C,Re="<li>You don’t have usage cost since everything runs on the player’s computer.</li> <li>The player does not need to be connected to the Internet.</li>",pe,b,fe,R,Ue="<li>You use the RAM/VRAM of the player so you need to specify spec recommendations</li> <li>You can’t easily know how people use the game or the model.</li>",de,U,ke="Since the sentence similarity model we’re going to use is small, <strong>we decided to run it locally</strong>.",he,B,ce;return u=new Y({props:{title:"How to run an AI model: local vs remote",local:"how-to-run-an-ai-model-local-vs-remote",headingTag:"h1"}}),c=new Y({props:{title:"Running the model remotely",local:"running-the-model-remotely",headingTag:"h2"}}),w=new Y({props:{title:"Advantages",local:"advantages",headingTag:"h2"}}),_=new Y({props:{title:"Disadvantages",local:"disadvantages",headingTag:"h2"}}),I=new Y({props:{title:"Running the model locally",local:"running-the-model-locally",headingTag:"h2"}}),P=new Y({props:{title:"Advantages",local:"advantages",headingTag:"h3"}}),b=new Y({props:{title:"Disadvantages",local:"disadvantages",headingTag:"h3"}}),{c(){m=s("meta"),G=i(),z=s("p"),V=i(),k(u.$$.fragment),N=i(),g=s("p"),g.innerHTML=ye,O=i(),p=s("p"),p.innerHTML=$e,J=i(),f=s("p"),f.textContent=we,K=i(),d=s("ul"),d.innerHTML=Te,Q=i(),h=s("p"),h.innerHTML=_e,W=i(),k(c.$$.fragment),X=i(),v=s("p"),v.innerHTML=Le,Z=i(),y=s("img"),ee=i(),$=s("p"),$.innerHTML=Ie,te=i(),k(w.$$.fragment),le=i(),T=s("ul"),T.innerHTML=He,ne=i(),k(_.$$.fragment),ie=i(),L=s("ul"),L.innerHTML=Ae,ae=i(),M=s("p"),M.textContent=xe,se=i(),k(I.$$.fragment),oe=i(),H=s("p"),H.textContent=Pe,re=i(),A=s("ol"),A.innerHTML=Ce,me=i(),x=s("img"),ue=i(),k(P.$$.fragment),ge=i(),C=s("ul"),C.innerHTML=Re,pe=i(),k(b.$$.fragment),fe=i(),R=s("ul"),R.innerHTML=Ue,de=i(),U=s("p"),U.innerHTML=ke,he=i(),B=s("p"),this.h()},l(e){const t=ze("svelte-u9bgzb",document.head);m=o(t,"META",{name:!0,content:!0}),t.forEach(l),G=a(e),z=o(e,"P",{}),Se(z).forEach(l),V=a(e),j(u.$$.fragment,e),N=a(e),g=o(e,"P",{"data-svelte-h":!0}),r(g)!=="svelte-iyzv6a"&&(g.innerHTML=ye),O=a(e),p=o(e,"P",{"data-svelte-h":!0}),r(p)!=="svelte-tfnlma"&&(p.innerHTML=$e),J=a(e),f=o(e,"P",{"data-svelte-h":!0}),r(f)!=="svelte-3w5216"&&(f.textContent=we),K=a(e),d=o(e,"UL",{"data-svelte-h":!0}),r(d)!=="svelte-1mnrhrg"&&(d.innerHTML=Te),Q=a(e),h=o(e,"P",{"data-svelte-h":!0}),r(h)!=="svelte-64mdo2"&&(h.innerHTML=_e),W=a(e),j(c.$$.fragment,e),X=a(e),v=o(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-wh55ai"&&(v.innerHTML=Le),Z=a(e),y=o(e,"IMG",{src:!0,alt:!0}),ee=a(e),$=o(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-xpvy17"&&($.innerHTML=Ie),te=a(e),j(w.$$.fragment,e),le=a(e),T=o(e,"UL",{"data-svelte-h":!0}),r(T)!=="svelte-krhajt"&&(T.innerHTML=He),ne=a(e),j(_.$$.fragment,e),ie=a(e),L=o(e,"UL",{"data-svelte-h":!0}),r(L)!=="svelte-kmhnz0"&&(L.innerHTML=Ae),ae=a(e),M=o(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-n1obm"&&(M.textContent=xe),se=a(e),j(I.$$.fragment,e),oe=a(e),H=o(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-1tp0rms"&&(H.textContent=Pe),re=a(e),A=o(e,"OL",{"data-svelte-h":!0}),r(A)!=="svelte-1rpw1li"&&(A.innerHTML=Ce),me=a(e),x=o(e,"IMG",{src:!0,alt:!0}),ue=a(e),j(P.$$.fragment,e),ge=a(e),C=o(e,"UL",{"data-svelte-h":!0}),r(C)!=="svelte-4rjpqe"&&(C.innerHTML=Re),pe=a(e),j(b.$$.fragment,e),fe=a(e),R=o(e,"UL",{"data-svelte-h":!0}),r(R)!=="svelte-86x825"&&(R.innerHTML=Ue),de=a(e),U=o(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-1dynhkd"&&(U.innerHTML=ke),he=a(e),B=o(e,"P",{}),Se(B).forEach(l),this.h()},h(){q(m,"name","hf:doc:metadata"),q(m,"content",Ve),je(y.src,Me="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/remote.jpg")||q(y,"src",Me),q(y,"alt","Running AI model remotely"),je(x.src,be="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/local.jpg")||q(x,"src",be),q(x,"alt","Running AI model locally")},m(e,t){Be(document.head,m),n(e,G,t),n(e,z,t),n(e,V,t),S(u,e,t),n(e,N,t),n(e,g,t),n(e,O,t),n(e,p,t),n(e,J,t),n(e,f,t),n(e,K,t),n(e,d,t),n(e,Q,t),n(e,h,t),n(e,W,t),S(c,e,t),n(e,X,t),n(e,v,t),n(e,Z,t),n(e,y,t),n(e,ee,t),n(e,$,t),n(e,te,t),S(w,e,t),n(e,le,t),n(e,T,t),n(e,ne,t),S(_,e,t),n(e,ie,t),n(e,L,t),n(e,ae,t),n(e,M,t),n(e,se,t),S(I,e,t),n(e,oe,t),n(e,H,t),n(e,re,t),n(e,A,t),n(e,me,t),n(e,x,t),n(e,ue,t),S(P,e,t),n(e,ge,t),n(e,C,t),n(e,pe,t),S(b,e,t),n(e,fe,t),n(e,R,t),n(e,de,t),n(e,U,t),n(e,he,t),n(e,B,t),ce=!0},p:Ee,i(e){ce||(D(u.$$.fragment,e),D(c.$$.fragment,e),D(w.$$.fragment,e),D(_.$$.fragment,e),D(I.$$.fragment,e),D(P.$$.fragment,e),D(b.$$.fragment,e),ce=!0)},o(e){E(u.$$.fragment,e),E(c.$$.fragment,e),E(w.$$.fragment,e),E(_.$$.fragment,e),E(I.$$.fragment,e),E(P.$$.fragment,e),E(b.$$.fragment,e),ce=!1},d(e){e&&(l(G),l(z),l(V),l(N),l(g),l(O),l(p),l(J),l(f),l(K),l(d),l(Q),l(h),l(W),l(X),l(v),l(Z),l(y),l(ee),l($),l(te),l(le),l(T),l(ne),l(ie),l(L),l(ae),l(M),l(se),l(oe),l(H),l(re),l(A),l(me),l(x),l(ue),l(ge),l(C),l(pe),l(fe),l(R),l(de),l(U),l(he),l(B)),l(m),F(u,e),F(c,e),F(w,e),F(_,e),F(I,e),F(P,e),F(b,e)}}}const Ve='{"title":"How to run an AI model: local vs remote","local":"how-to-run-an-ai-model-local-vs-remote","sections":[{"title":"Running the model remotely","local":"running-the-model-remotely","sections":[],"depth":2},{"title":"Advantages","local":"advantages","sections":[],"depth":2},{"title":"Disadvantages","local":"disadvantages","sections":[],"depth":2},{"title":"Running the model locally","local":"running-the-model-locally","sections":[{"title":"Advantages","local":"advantages","sections":[],"depth":3},{"title":"Disadvantages","local":"disadvantages","sections":[],"depth":3}],"depth":2}],"depth":1}';function Ne(ve){return Fe(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Qe extends Ye{constructor(m){super(),qe(this,m,Ne,Ge,De,{})}}export{Qe as component};
