import{s as rl,f as m,n as ol,o as ul}from"../chunks/scheduler.63274e7e.js";import{S as ml,i as pl,g as a,s as n,r as p,A as fl,h as r,f as i,c as s,j as al,u as f,x as o,k as u,y as hl,a as l,v as h,d as g,t as c,w as v}from"../chunks/index.bf3f3f8e.js";import{H as d}from"../chunks/Heading.500d2301.js";function gl(ti){let w,At,Gt,Ot,_,qt,x,zt,M,ei='You can find the 👉 <a href="https://huggingface.co/datasets/huggingface-ml-4-games-course/unity-demos/resolve/main/unit1/Jammo%20the%20Robot%20Sentis%20(v2).zip?download=true" rel="nofollow">complete Unity project here</a>',Rt,L,Bt,C,ii='The Sentis Documentation 👉 <a href="https://docs.unity3d.com/Packages/com.unity.sentis@latest" rel="nofollow">https://docs.unity3d.com/Packages/com.unity.sentis@latest</a>',Jt,$,li='<li><p>Open the Jammo project</p></li> <li><p>Click <a href="https://tinyurl.com/4eun48fb" rel="nofollow">Sentis Pre-Release package</a> or go to Window &gt; Package Manager, click the + icon, select “Add package by name…” and type “com.unity.sentis”</p></li>',Wt,H,ni,Et,y,si="<li>Press the Add button to install the package.</li>",Ft,S,ai,Nt,P,Yt,k,ri='<a href="https://github.com/huggingface/sharp-transformers" rel="nofollow">Sharp Transformers</a> is a Unity plugin of utilities to <strong>run Transformer 🤗 models in Unity games</strong>.',Dt,I,oi="We need to do it for the tokenization step.",Vt,j,ui="Go to “Window” > “Package Manager” to open the Package Manager.",Kt,G,mi="Click the ”+” in the upper left-hand corner and select “Add package from git URL”.",Qt,U,pi='Enter the URL of this repository and click “Add”: <a href="https://github.com/huggingface/sharp-transformers.git" rel="nofollow">https://github.com/huggingface/sharp-transformers.git</a>',Xt,A,Zt,O,fi='As described in <a href="https://docs.unity3d.com/Packages/com.unity.sentis@latest" rel="nofollow">Sentis documentation</a>, to use Sentis to run a neural network in Unity, we need to follow these steps.',te,q,hi="<li><p>Use the Unity.Sentis namespace.</p></li> <li><p><strong>Load a neural network</strong> model file.</p></li> <li><p><strong>Create input</strong> for the model.</p></li> <li><p><strong>Create an inference engine</strong> (a worker).</p></li> <li><p><strong>Run the model</strong> with the input to infer a result.</p></li> <li><p><strong>Get the result</strong>.</p></li>",ee,z,gi="In our case, we do all of this in <strong>SentenceSimilarity.cs</strong> file, that will be attached to our robot.",ie,R,ci="In awake, we:",le,B,vi="<li><p><strong>Load our neural network.</strong></p></li> <li><p>Create an <strong>inference engine</strong> (a worker).</p></li> <li><p><strong>Create an operator</strong>, that will allow us to perform operations with tensors.</p></li>",ne,J,di,se,W,wi="We have three functions:",ae,E,yi="<li><em>Encode</em>: takes our player input (text), <strong>tokenizes it, and embeds it</strong>.</li>",re,F,bi,oe,b,Ti="<li><em>SentenceSimilarityScores</em>: <strong>calculate the similarity scores</strong> between the input embed (what the user typed) and the comparison embeds (the robot action list)</li>",ue,N,_i,me,T,xi="<li><em>RankSimilarityScores</em>: get the <strong>most similar action</strong> and its index given the player input</li>",pe,Y,Mi,fe,D,he,V,Li="We need to define the <strong>behavior of our robot</strong>.",ge,K,Ci="The idea is that our robot has different possible actions and the choice of the actions <strong>will depend on most similar actions</strong>.",ce,Q,$i="We need first to define the <em>Finite State Machine</em>, a simple <strong>classical AI technique where each State defines a certain behavior</strong>.",ve,X,Hi="Then, we’ll make the utility function <strong>that will select the State hence the series of actions to perform</strong>.",de,Z,we,tt,Si="In a state machine, <strong>each state represents a behavior</strong>, for instance, moving to a column, saying hello, etc. Based on the state the agent is <strong>it will perform a series of actions</strong>.",ye,et,Pi="In our case, we have 7 states:",be,it,ki,Te,lt,Ii="The first thing we need to do is create an enum called State that contains each of the possible States:",_e,nt,ji,xe,st,Gi="Because we need to constantly check the state, <strong>we define the state machine into the Update() method using a switch system where each case is a state</strong>.",Me,at,Ui,Le,rt,Ai="For each state case, we define the behavior of our agents, for instance in our state Hello, the robot <strong>must move towards the player, face him correctly, and then launch its Hello animation, then go back to an Idle State</strong>.",Ce,ot,Oi,$e,ut,qi="We have now defined the behavior for each different State. The magic here will come from the fact <strong>that’s the language model that will define what State is the closest to the Player input</strong>. And in the utility function, we call this state.",He,mt,Se,pt,zi="Our action list looks like this:",Pe,ft,Ri,ke,ht,Bi="<li><p>The sentence is what will be embedded in the AI model.</p></li> <li><p>The verb is the State</p></li> <li><p>Noun (if any) is the object to interact with (Pillar, Cube, etc.)</p></li>",Ie,gt,Ji="This utility function will <strong>select the Verb and Noun associated with the sentence having the highest similarity score with the player input text.</strong>",je,ct,Wi="But first, to <strong>get rid of a lot of strange input text</strong>, we need to have a similarity <strong>score threshold</strong>.",Ge,vt,Ei="For example, if I say “Look at all the rabbits”, <strong>none of our possible actions are relevant</strong>. Hence instead of choosing the action with the highest score, we’ll call the State Puzzled which will animate the robot with a perplexed animation.",Ue,dt,Fi,Ae,wt,Ni="If the score is higher, then <strong>we’ll get the verb corresponding to a State and the noun (goalObject) if any</strong>.",Oe,yt,Yi="We set the state corresponding to the verb. That will activate the behavior corresponding to it.",qe,bt,Di,ze,Tt,Vi="And that’s it, <strong>now we’re ready to interact with our robot!</strong>",Re,_t,Be,xt,Ki="In this step, you just need to click on the play button in the editor. And you <strong>can prompt some orders and see the results</strong>!",Je,Mt,Qi="That’s nice! But the best way to learn is to try things, break things and modify the demo.",We,Lt,Ee,Ct,Xi="Adding a new action is quite easy. Let’s take an example:",Fe,$t,Zi="<li><p>Copy the YellowPillar game object and move it</p></li> <li><p>Change the name to GreenPillar</p></li> <li><p>Create a new material and set it to green</p></li> <li><p>Place the material on GreenPillar</p></li>",Ne,Ht,tl="Now that we’ve placed the new game object, we need to add this possibility into the sentences and click on Jammo_Player.",Ye,St,el="In the list of actions click on the plus button and fill in this new action item:",De,Pt,il,Ve,kt,ll="<li>Add Go to the green column</li> <li>GoTo</li> <li>GreenColumn</li>",Ke,It,nl="And that’s it! <strong>You can easily iterate and add more actions to your game</strong>.",Qe,jt,sl="Again, don’t forget to test the similarity threshold, <strong>to see if you need to increase it or decrease it</strong>.",Xe,Ut,Ze;return _=new d({props:{title:"Let’s build our smart robot NPC demo 🤖",local:"lets-build-our-smart-robot-npc-demo-",headingTag:"h1"}}),x=new d({props:{title:"Step 0: Get the project files",local:"step-0-get-the-project-files",headingTag:"h2"}}),L=new d({props:{title:"Step 1: Install Unity Sentis",local:"step-1-install-unity-sentis",headingTag:"h2"}}),P=new d({props:{title:"Step 2: Install Sharp Transformers 💪",local:"step-2-install-sharp-transformers-",headingTag:"h2"}}),A=new d({props:{title:"Step 3: Build the inference process 🧠",local:"step-3-build-the-inference-process-",headingTag:"h2"}}),D=new d({props:{title:"Step 4: Build the Robot Behavior 🤖",local:"step-4-build-the-robot-behavior-",headingTag:"h2"}}),Z=new d({props:{title:"The State Machine 🧠🤖",local:"the-state-machine-",headingTag:"h3"}}),mt=new d({props:{title:"Let’s define the Utility Function 📈",local:"lets-define-the-utility-function-",headingTag:"h3"}}),_t=new d({props:{title:"Step 5: Let’s interact with our Robot 🤖",local:"step-5-lets-interact-with-our-robot-",headingTag:"h2"}}),Lt=new d({props:{title:"(Optional) Improving the game: let’s add a new action",local:"optional-improving-the-game-lets-add-a-new-action",headingTag:"h2"}}),{c(){w=a("meta"),At=n(),Gt=a("p"),Ot=n(),p(_.$$.fragment),qt=n(),p(x.$$.fragment),zt=n(),M=a("p"),M.innerHTML=ei,Rt=n(),p(L.$$.fragment),Bt=n(),C=a("p"),C.innerHTML=ii,Jt=n(),$=a("ol"),$.innerHTML=li,Wt=n(),H=a("img"),Et=n(),y=a("ol"),y.innerHTML=si,Ft=n(),S=a("img"),Nt=n(),p(P.$$.fragment),Yt=n(),k=a("p"),k.innerHTML=ri,Dt=n(),I=a("p"),I.textContent=oi,Vt=n(),j=a("p"),j.textContent=ui,Kt=n(),G=a("p"),G.textContent=mi,Qt=n(),U=a("p"),U.innerHTML=pi,Xt=n(),p(A.$$.fragment),Zt=n(),O=a("p"),O.innerHTML=fi,te=n(),q=a("ol"),q.innerHTML=hi,ee=n(),z=a("p"),z.innerHTML=gi,ie=n(),R=a("p"),R.textContent=ci,le=n(),B=a("ol"),B.innerHTML=vi,ne=n(),J=a("img"),se=n(),W=a("p"),W.textContent=wi,ae=n(),E=a("ol"),E.innerHTML=yi,re=n(),F=a("img"),oe=n(),b=a("ol"),b.innerHTML=Ti,ue=n(),N=a("img"),me=n(),T=a("ol"),T.innerHTML=xi,pe=n(),Y=a("img"),fe=n(),p(D.$$.fragment),he=n(),V=a("p"),V.innerHTML=Li,ge=n(),K=a("p"),K.innerHTML=Ci,ce=n(),Q=a("p"),Q.innerHTML=$i,ve=n(),X=a("p"),X.innerHTML=Hi,de=n(),p(Z.$$.fragment),we=n(),tt=a("p"),tt.innerHTML=Si,ye=n(),et=a("p"),et.textContent=Pi,be=n(),it=a("img"),Te=n(),lt=a("p"),lt.textContent=Ii,_e=n(),nt=a("img"),xe=n(),st=a("p"),st.innerHTML=Gi,Me=n(),at=a("img"),Le=n(),rt=a("p"),rt.innerHTML=Ai,Ce=n(),ot=a("img"),$e=n(),ut=a("p"),ut.innerHTML=qi,He=n(),p(mt.$$.fragment),Se=n(),pt=a("p"),pt.textContent=zi,Pe=n(),ft=a("img"),ke=n(),ht=a("ul"),ht.innerHTML=Bi,Ie=n(),gt=a("p"),gt.innerHTML=Ji,je=n(),ct=a("p"),ct.innerHTML=Wi,Ge=n(),vt=a("p"),vt.innerHTML=Ei,Ue=n(),dt=a("img"),Ae=n(),wt=a("p"),wt.innerHTML=Ni,Oe=n(),yt=a("p"),yt.textContent=Yi,qe=n(),bt=a("img"),ze=n(),Tt=a("p"),Tt.innerHTML=Vi,Re=n(),p(_t.$$.fragment),Be=n(),xt=a("p"),xt.innerHTML=Ki,Je=n(),Mt=a("p"),Mt.textContent=Qi,We=n(),p(Lt.$$.fragment),Ee=n(),Ct=a("p"),Ct.textContent=Xi,Fe=n(),$t=a("ul"),$t.innerHTML=Zi,Ne=n(),Ht=a("p"),Ht.textContent=tl,Ye=n(),St=a("p"),St.textContent=el,De=n(),Pt=a("img"),Ve=n(),kt=a("ul"),kt.innerHTML=ll,Ke=n(),It=a("p"),It.innerHTML=nl,Qe=n(),jt=a("p"),jt.innerHTML=sl,Xe=n(),Ut=a("p"),this.h()},l(t){const e=fl("svelte-u9bgzb",document.head);w=r(e,"META",{name:!0,content:!0}),e.forEach(i),At=s(t),Gt=r(t,"P",{}),al(Gt).forEach(i),Ot=s(t),f(_.$$.fragment,t),qt=s(t),f(x.$$.fragment,t),zt=s(t),M=r(t,"P",{"data-svelte-h":!0}),o(M)!=="svelte-1yl9hlo"&&(M.innerHTML=ei),Rt=s(t),f(L.$$.fragment,t),Bt=s(t),C=r(t,"P",{"data-svelte-h":!0}),o(C)!=="svelte-opv8w8"&&(C.innerHTML=ii),Jt=s(t),$=r(t,"OL",{"data-svelte-h":!0}),o($)!=="svelte-1be145u"&&($.innerHTML=li),Wt=s(t),H=r(t,"IMG",{src:!0,alt:!0}),Et=s(t),y=r(t,"OL",{start:!0,"data-svelte-h":!0}),o(y)!=="svelte-5tt8x1"&&(y.innerHTML=si),Ft=s(t),S=r(t,"IMG",{src:!0,alt:!0}),Nt=s(t),f(P.$$.fragment,t),Yt=s(t),k=r(t,"P",{"data-svelte-h":!0}),o(k)!=="svelte-1z124e9"&&(k.innerHTML=ri),Dt=s(t),I=r(t,"P",{"data-svelte-h":!0}),o(I)!=="svelte-xasv72"&&(I.textContent=oi),Vt=s(t),j=r(t,"P",{"data-svelte-h":!0}),o(j)!=="svelte-1qa8kbx"&&(j.textContent=ui),Kt=s(t),G=r(t,"P",{"data-svelte-h":!0}),o(G)!=="svelte-19zcx5u"&&(G.textContent=mi),Qt=s(t),U=r(t,"P",{"data-svelte-h":!0}),o(U)!=="svelte-1bqyha7"&&(U.innerHTML=pi),Xt=s(t),f(A.$$.fragment,t),Zt=s(t),O=r(t,"P",{"data-svelte-h":!0}),o(O)!=="svelte-gwh6bq"&&(O.innerHTML=fi),te=s(t),q=r(t,"OL",{"data-svelte-h":!0}),o(q)!=="svelte-11c6hj8"&&(q.innerHTML=hi),ee=s(t),z=r(t,"P",{"data-svelte-h":!0}),o(z)!=="svelte-1bxothf"&&(z.innerHTML=gi),ie=s(t),R=r(t,"P",{"data-svelte-h":!0}),o(R)!=="svelte-17c2lau"&&(R.textContent=ci),le=s(t),B=r(t,"OL",{"data-svelte-h":!0}),o(B)!=="svelte-1mwm3hf"&&(B.innerHTML=vi),ne=s(t),J=r(t,"IMG",{src:!0,alt:!0}),se=s(t),W=r(t,"P",{"data-svelte-h":!0}),o(W)!=="svelte-gchvph"&&(W.textContent=wi),ae=s(t),E=r(t,"OL",{"data-svelte-h":!0}),o(E)!=="svelte-1bbbmof"&&(E.innerHTML=yi),re=s(t),F=r(t,"IMG",{src:!0,alt:!0}),oe=s(t),b=r(t,"OL",{start:!0,"data-svelte-h":!0}),o(b)!=="svelte-ehcevs"&&(b.innerHTML=Ti),ue=s(t),N=r(t,"IMG",{src:!0,alt:!0}),me=s(t),T=r(t,"OL",{start:!0,"data-svelte-h":!0}),o(T)!=="svelte-q0d6cq"&&(T.innerHTML=xi),pe=s(t),Y=r(t,"IMG",{src:!0,alt:!0}),fe=s(t),f(D.$$.fragment,t),he=s(t),V=r(t,"P",{"data-svelte-h":!0}),o(V)!=="svelte-15whxm9"&&(V.innerHTML=Li),ge=s(t),K=r(t,"P",{"data-svelte-h":!0}),o(K)!=="svelte-1lrk8k1"&&(K.innerHTML=Ci),ce=s(t),Q=r(t,"P",{"data-svelte-h":!0}),o(Q)!=="svelte-1kn8gok"&&(Q.innerHTML=$i),ve=s(t),X=r(t,"P",{"data-svelte-h":!0}),o(X)!=="svelte-4iyzzc"&&(X.innerHTML=Hi),de=s(t),f(Z.$$.fragment,t),we=s(t),tt=r(t,"P",{"data-svelte-h":!0}),o(tt)!=="svelte-5rbi8n"&&(tt.innerHTML=Si),ye=s(t),et=r(t,"P",{"data-svelte-h":!0}),o(et)!=="svelte-1fffpiy"&&(et.textContent=Pi),be=s(t),it=r(t,"IMG",{src:!0,alt:!0}),Te=s(t),lt=r(t,"P",{"data-svelte-h":!0}),o(lt)!=="svelte-2wbpmd"&&(lt.textContent=Ii),_e=s(t),nt=r(t,"IMG",{src:!0,alt:!0}),xe=s(t),st=r(t,"P",{"data-svelte-h":!0}),o(st)!=="svelte-120cind"&&(st.innerHTML=Gi),Me=s(t),at=r(t,"IMG",{src:!0,alt:!0}),Le=s(t),rt=r(t,"P",{"data-svelte-h":!0}),o(rt)!=="svelte-1shiqaw"&&(rt.innerHTML=Ai),Ce=s(t),ot=r(t,"IMG",{src:!0,alt:!0}),$e=s(t),ut=r(t,"P",{"data-svelte-h":!0}),o(ut)!=="svelte-1jrao99"&&(ut.innerHTML=qi),He=s(t),f(mt.$$.fragment,t),Se=s(t),pt=r(t,"P",{"data-svelte-h":!0}),o(pt)!=="svelte-bsbp3"&&(pt.textContent=zi),Pe=s(t),ft=r(t,"IMG",{src:!0,alt:!0}),ke=s(t),ht=r(t,"UL",{"data-svelte-h":!0}),o(ht)!=="svelte-6bwl87"&&(ht.innerHTML=Bi),Ie=s(t),gt=r(t,"P",{"data-svelte-h":!0}),o(gt)!=="svelte-16jnw1u"&&(gt.innerHTML=Ji),je=s(t),ct=r(t,"P",{"data-svelte-h":!0}),o(ct)!=="svelte-gpawhm"&&(ct.innerHTML=Wi),Ge=s(t),vt=r(t,"P",{"data-svelte-h":!0}),o(vt)!=="svelte-1hi969r"&&(vt.innerHTML=Ei),Ue=s(t),dt=r(t,"IMG",{src:!0,alt:!0}),Ae=s(t),wt=r(t,"P",{"data-svelte-h":!0}),o(wt)!=="svelte-idtp6m"&&(wt.innerHTML=Ni),Oe=s(t),yt=r(t,"P",{"data-svelte-h":!0}),o(yt)!=="svelte-1yk26hk"&&(yt.textContent=Yi),qe=s(t),bt=r(t,"IMG",{src:!0,alt:!0}),ze=s(t),Tt=r(t,"P",{"data-svelte-h":!0}),o(Tt)!=="svelte-hcv1yn"&&(Tt.innerHTML=Vi),Re=s(t),f(_t.$$.fragment,t),Be=s(t),xt=r(t,"P",{"data-svelte-h":!0}),o(xt)!=="svelte-1kbnmju"&&(xt.innerHTML=Ki),Je=s(t),Mt=r(t,"P",{"data-svelte-h":!0}),o(Mt)!=="svelte-1t6d83x"&&(Mt.textContent=Qi),We=s(t),f(Lt.$$.fragment,t),Ee=s(t),Ct=r(t,"P",{"data-svelte-h":!0}),o(Ct)!=="svelte-1rlfwth"&&(Ct.textContent=Xi),Fe=s(t),$t=r(t,"UL",{"data-svelte-h":!0}),o($t)!=="svelte-1dl51k5"&&($t.innerHTML=Zi),Ne=s(t),Ht=r(t,"P",{"data-svelte-h":!0}),o(Ht)!=="svelte-22rtac"&&(Ht.textContent=tl),Ye=s(t),St=r(t,"P",{"data-svelte-h":!0}),o(St)!=="svelte-18hx0iy"&&(St.textContent=el),De=s(t),Pt=r(t,"IMG",{src:!0,alt:!0}),Ve=s(t),kt=r(t,"UL",{"data-svelte-h":!0}),o(kt)!=="svelte-q2rtbz"&&(kt.innerHTML=ll),Ke=s(t),It=r(t,"P",{"data-svelte-h":!0}),o(It)!=="svelte-wsbu0l"&&(It.innerHTML=nl),Qe=s(t),jt=r(t,"P",{"data-svelte-h":!0}),o(jt)!=="svelte-11a9ito"&&(jt.innerHTML=sl),Xe=s(t),Ut=r(t,"P",{}),al(Ut).forEach(i),this.h()},h(){u(w,"name","hf:doc:metadata"),u(w,"content",cl),m(H.src,ni="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis1.jpg")||u(H,"src",ni),u(H,"alt","Sentis"),u(y,"start","3"),m(S.src,ai="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis2.png")||u(S,"src",ai),u(S,"alt","Sentis"),m(J.src,di="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity1.jpg")||u(J,"src",di),u(J,"alt","Sentis Similarity"),m(F.src,bi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity2.jpg")||u(F,"src",bi),u(F,"alt","Sentis Similarity"),u(b,"start","2"),m(N.src,_i="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity3.jpg")||u(N,"src",_i),u(N,"alt","Sentis Similarity"),u(T,"start","3"),m(Y.src,Mi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/sentis-similarity4.jpg")||u(Y,"src",Mi),u(Y,"alt","Sentis Similarity"),m(it.src,ki="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm.jpg")||u(it,"src",ki),u(it,"alt","Jammo State Machine"),m(nt.src,ji="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm2.jpg")||u(nt,"src",ji),u(nt,"alt","Jammo State Machine"),m(at.src,Ui="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm3.jpg")||u(at,"src",Ui),u(at,"alt","Jammo State Machine"),m(ot.src,Oi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/fsm4.jpg")||u(ot,"src",Oi),u(ot,"alt","Jammo State Machine"),m(ft.src,Ri="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/utility1.jpg")||u(ft,"src",Ri),u(ft,"alt","Utility"),m(dt.src,Fi="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/rabbits.gif")||u(dt,"src",Fi),u(dt,"alt","Jammo rabbits"),m(bt.src,Di="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/utility2.jpg")||u(bt,"src",Di),u(bt,"alt","Utility"),m(Pt.src,il="https://huggingface.co/datasets/huggingface-ml-4-games-course/course-images/resolve/main/en/unit1/unity/optional-jammo1.jpg")||u(Pt,"src",il),u(Pt,"alt","Utility")},m(t,e){hl(document.head,w),l(t,At,e),l(t,Gt,e),l(t,Ot,e),h(_,t,e),l(t,qt,e),h(x,t,e),l(t,zt,e),l(t,M,e),l(t,Rt,e),h(L,t,e),l(t,Bt,e),l(t,C,e),l(t,Jt,e),l(t,$,e),l(t,Wt,e),l(t,H,e),l(t,Et,e),l(t,y,e),l(t,Ft,e),l(t,S,e),l(t,Nt,e),h(P,t,e),l(t,Yt,e),l(t,k,e),l(t,Dt,e),l(t,I,e),l(t,Vt,e),l(t,j,e),l(t,Kt,e),l(t,G,e),l(t,Qt,e),l(t,U,e),l(t,Xt,e),h(A,t,e),l(t,Zt,e),l(t,O,e),l(t,te,e),l(t,q,e),l(t,ee,e),l(t,z,e),l(t,ie,e),l(t,R,e),l(t,le,e),l(t,B,e),l(t,ne,e),l(t,J,e),l(t,se,e),l(t,W,e),l(t,ae,e),l(t,E,e),l(t,re,e),l(t,F,e),l(t,oe,e),l(t,b,e),l(t,ue,e),l(t,N,e),l(t,me,e),l(t,T,e),l(t,pe,e),l(t,Y,e),l(t,fe,e),h(D,t,e),l(t,he,e),l(t,V,e),l(t,ge,e),l(t,K,e),l(t,ce,e),l(t,Q,e),l(t,ve,e),l(t,X,e),l(t,de,e),h(Z,t,e),l(t,we,e),l(t,tt,e),l(t,ye,e),l(t,et,e),l(t,be,e),l(t,it,e),l(t,Te,e),l(t,lt,e),l(t,_e,e),l(t,nt,e),l(t,xe,e),l(t,st,e),l(t,Me,e),l(t,at,e),l(t,Le,e),l(t,rt,e),l(t,Ce,e),l(t,ot,e),l(t,$e,e),l(t,ut,e),l(t,He,e),h(mt,t,e),l(t,Se,e),l(t,pt,e),l(t,Pe,e),l(t,ft,e),l(t,ke,e),l(t,ht,e),l(t,Ie,e),l(t,gt,e),l(t,je,e),l(t,ct,e),l(t,Ge,e),l(t,vt,e),l(t,Ue,e),l(t,dt,e),l(t,Ae,e),l(t,wt,e),l(t,Oe,e),l(t,yt,e),l(t,qe,e),l(t,bt,e),l(t,ze,e),l(t,Tt,e),l(t,Re,e),h(_t,t,e),l(t,Be,e),l(t,xt,e),l(t,Je,e),l(t,Mt,e),l(t,We,e),h(Lt,t,e),l(t,Ee,e),l(t,Ct,e),l(t,Fe,e),l(t,$t,e),l(t,Ne,e),l(t,Ht,e),l(t,Ye,e),l(t,St,e),l(t,De,e),l(t,Pt,e),l(t,Ve,e),l(t,kt,e),l(t,Ke,e),l(t,It,e),l(t,Qe,e),l(t,jt,e),l(t,Xe,e),l(t,Ut,e),Ze=!0},p:ol,i(t){Ze||(g(_.$$.fragment,t),g(x.$$.fragment,t),g(L.$$.fragment,t),g(P.$$.fragment,t),g(A.$$.fragment,t),g(D.$$.fragment,t),g(Z.$$.fragment,t),g(mt.$$.fragment,t),g(_t.$$.fragment,t),g(Lt.$$.fragment,t),Ze=!0)},o(t){c(_.$$.fragment,t),c(x.$$.fragment,t),c(L.$$.fragment,t),c(P.$$.fragment,t),c(A.$$.fragment,t),c(D.$$.fragment,t),c(Z.$$.fragment,t),c(mt.$$.fragment,t),c(_t.$$.fragment,t),c(Lt.$$.fragment,t),Ze=!1},d(t){t&&(i(At),i(Gt),i(Ot),i(qt),i(zt),i(M),i(Rt),i(Bt),i(C),i(Jt),i($),i(Wt),i(H),i(Et),i(y),i(Ft),i(S),i(Nt),i(Yt),i(k),i(Dt),i(I),i(Vt),i(j),i(Kt),i(G),i(Qt),i(U),i(Xt),i(Zt),i(O),i(te),i(q),i(ee),i(z),i(ie),i(R),i(le),i(B),i(ne),i(J),i(se),i(W),i(ae),i(E),i(re),i(F),i(oe),i(b),i(ue),i(N),i(me),i(T),i(pe),i(Y),i(fe),i(he),i(V),i(ge),i(K),i(ce),i(Q),i(ve),i(X),i(de),i(we),i(tt),i(ye),i(et),i(be),i(it),i(Te),i(lt),i(_e),i(nt),i(xe),i(st),i(Me),i(at),i(Le),i(rt),i(Ce),i(ot),i($e),i(ut),i(He),i(Se),i(pt),i(Pe),i(ft),i(ke),i(ht),i(Ie),i(gt),i(je),i(ct),i(Ge),i(vt),i(Ue),i(dt),i(Ae),i(wt),i(Oe),i(yt),i(qe),i(bt),i(ze),i(Tt),i(Re),i(Be),i(xt),i(Je),i(Mt),i(We),i(Ee),i(Ct),i(Fe),i($t),i(Ne),i(Ht),i(Ye),i(St),i(De),i(Pt),i(Ve),i(kt),i(Ke),i(It),i(Qe),i(jt),i(Xe),i(Ut)),i(w),v(_,t),v(x,t),v(L,t),v(P,t),v(A,t),v(D,t),v(Z,t),v(mt,t),v(_t,t),v(Lt,t)}}}const cl='{"title":"Let’s build our smart robot NPC demo 🤖","local":"lets-build-our-smart-robot-npc-demo-","sections":[{"title":"Step 0: Get the project files","local":"step-0-get-the-project-files","sections":[],"depth":2},{"title":"Step 1: Install Unity Sentis","local":"step-1-install-unity-sentis","sections":[],"depth":2},{"title":"Step 2: Install Sharp Transformers 💪","local":"step-2-install-sharp-transformers-","sections":[],"depth":2},{"title":"Step 3: Build the inference process 🧠","local":"step-3-build-the-inference-process-","sections":[],"depth":2},{"title":"Step 4: Build the Robot Behavior 🤖","local":"step-4-build-the-robot-behavior-","sections":[{"title":"The State Machine 🧠🤖","local":"the-state-machine-","sections":[],"depth":3},{"title":"Let’s define the Utility Function 📈","local":"lets-define-the-utility-function-","sections":[],"depth":3}],"depth":2},{"title":"Step 5: Let’s interact with our Robot 🤖","local":"step-5-lets-interact-with-our-robot-","sections":[],"depth":2},{"title":"(Optional) Improving the game: let’s add a new action","local":"optional-improving-the-game-lets-add-a-new-action","sections":[],"depth":2}],"depth":1}';function vl(ti){return ul(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class bl extends ml{constructor(w){super(),pl(this,w,vl,gl,rl,{})}}export{bl as component};
